Skip to main content

1.1 Using Razorpay APIs

To create an authorisation transaction using Razorpay APIs, you need to:
1

[Create a Customer](#111-create-a-customer).

2

[Create an Order](#112-create-an-order).

3

[Create Authorisation Payment using Razorpay APIs](#113-create-an-a...

Handy Tips
For the Authorisation Payment to be successful in a day (for example, 5th June), you should create an Order and the Authorisation Transaction on the same day (5th June) before 11:59 pm.

1.1.1 Create a Customer

Razorpay links recurring tokens to customers via a unique identifier. This unique identifier for the customer is generated using the Customer API. You can create customers with basic details such as email and contact and use them for various Razorpay offerings. Know more about Customers. You can create a customer using the below endpoint. /customers
Curl
Once a customer is created, you can create an order for the authorization of the payment.

Request Parameters

name mandatory : string The customer’s name. For example, Gaurav Kumar. email mandatory : string The customer’s email address. For example, gaurav.kumar@example.com. contact mandatory : string The customer’s phone number. For example, 9876543210. fail_existing optional : string The request throws an exception by default if a customer with the exact details already exists. You can pass an additional parameter fail_existing to get the existing customer’s details in the response. Possible values:
  • 1 (default): If a customer with the same details already exists, throws an error.
  • 0: If a customer with the same details already exists, fetches details of the existing customer.
notes optional : object Key-value pair that can be used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, "note_key": "Beam me up Scotty”.

1.1.2. Create an Order

Use the Orders API to create a unique Razorpay order_id that is associated with the authorisation transaction. The following endpoint creates an order. /orders
Handy Tips
The subsequent payment frequency is displayed on your customer’s PSP. They can select the required frequency while registering for the mandate.
Curl
Success Response

Request Parameters

amount mandatory : integer Amount, in paise. currency mandatory : string The 3-letter ISO currency code for the payment. Currently, we only support INR. customer_id mandatory : string The unique identifier of the customer. For example, cust_4xbQrmEoA5WJ01. method mandatory : string Payment method for the authorisation transaction. Here, the value should be upi. receipt optional : string Unique identifier for the order entered by you. For example, Receipt No. 1. This parameter should be mapped to the order_id sent by Razorpay. notesoptional : object Key-value pair that can be used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, "note_key": "Beam me up Scotty”. token : Details related to the authorization such as max amount, frequency and expiry information. max_amount mandatory : integer The maximum amount that can be debited in a single charge.

MCC | Category | Min Value | Max Value

6211 | Financial Services | 100 (₹1) | 20000000 (₹2,00,000)

6300 | Financial Services | 100 (₹1) | 20000000 (₹2,00,000)

7322 | Financial Services | 100 (₹1) | 20000000 (₹2,00,000)

6529 | Financial Services | 100 (₹1) | 20000000 (₹2,00,000)

5960 | Services | 100 (₹1) | 20000000 (₹2,00,000) For other categories and MCCs, the minimum value is 100 (₹1) and maximum value is 9999900 (₹99,999). expire_at mandatory : integer The Unix timestamp that indicates when the authorisation transaction must expire. The default value is 10 years and the maximum value allowed is 30 years. frequency mandatory : string The frequency at which you can charge your customer. Possible values:
  • daily
  • weekly
  • fortnightly
  • bimonthly
  • monthly
  • quarterly
  • half_yearly
  • yearly
  • as_presented
recurring_value optional : integer Determines the exact date or range of dates for recurring debits. Possible values are:
  • 1-7 for weekly frequency
  • 1-31 for fortnightly frequency
  • 1-31 for bimonthly frequency
  • 1-31 for monthly frequency
  • 1-31 for quarterly frequency
  • 1-31 for half_yearly frequency
  • 1-31 for yearly frequency and is not applicable for the as_presented frequency.
Watch Out!If the date entered for the recurring debit is not available for a month, then the last day of the month is considered by default. For example, if the date entered is 31 and the month has only 28 days, then the date 28 is considered.recurring_type optional : string Determines when the recurring debit can be done. Possible values are:
  • on: Recurring debit happens on the exact day of every month.
Handy Tips
For creating an order with recurring_type=on, set the recurring_value parameter to the current date.
  • before: Recurring debit can happen any time before the specified date.
  • after: Recurring debit can happen any time after the specified date.
For example, if the frequency is monthly, recurring_value is 17 and recurring_type is before, recurring debit can happen between the month’s 1st and 17th. Similarly, if recurring_type is after, recurring debit can only happen on or after the 17th of the month.bank_account mandatory : Details of the bank account of the customer.account_number mandatory : integer The bank account number of the customer. For example, 123456789012345.name mandatory : string The name of the bank account holder.ifsc mandatory : The IFSC of the bank. For example, HDFC0000053.

Error Response Parameters

Given below is a list of possible errors you may face while creating an Order.

Error | Cause | Solution

The id provided does not exist | This error occurs when you enter an incorrect customer_id. | Make sure to enter a valid customer_id.

The api key provided is invalid | This error occurs when you enter the wrong API key or secret. | Make sure to enter a valid API key and secret.

The amount must be at least INR 1.00. | This error occurs when you enter an amount less than INR 1. | Make sure the entered amount is atleast INR 1.00.

The currency should be INR when method is upi | This error occurs when you enter a currency other than INR | Make sure the currency is INR.

The amount field is required. | This error occurs when you have not entered the amount or the max_amount value. | Make sure to enter the max_amount value.

The minimum transaction amount allowed is Re. 5. | This error occurs when you enter the maximum amount less than the minimum amount. | Make sure the max_amount value is more than the min_amount value.

invaild_account_number | This error occurs when you have not entered the account_number. | Make sure to enter a valid account_number.

The order amount cannot be greater than the token max amount for upi recurring. | This error occurs when the order amount exceeds the token_max amount passed in the API request payload. | Ensure the order amount is lesser than the token_max account.

1.1.3. Create an Authorisation Payment

Create a payment checkout form for customers to make Authorisation Transaction and register their mandate. You can use the Handler Function or Callback URL.

Handler Function | Callback URL

When you use the handler function, the response object of the successful payment (razorpay_payment_id, razorpay_order_id and razorpay_signature) is submitted to the Checkout Form. You need to collect these and send them to your server. | When you use a Callback URL, the response object of the successful payment (razorpay_payment_id, razorpay_order_id and razorpay_signature) is submitted to the Callback URL.
Watch Out!
  • The callback URL is not supported for recurring payments created using the registration link.
  • While handling the first time authorisation payment response, consume the error_reason field with value upi_dummy_payment and error_description field with value Payment was a dummy payment for one time mandate registration. to identify successful mandate registration. The parent error_code will be BAD_REQUEST_ERROR.
Checkout with handler functions

Additional Checkout Fields

customer_id mandatory : string Unique identifier of the customer created in the first step.order_id mandatory : string Unique identifier of the order created in the second step.recurring mandatory : string Determines if the recurring payment is enabled or not. Possible values:
  • 1: Recurring payment is enabled.
  • preferred: Use this if you want to allow recurring payments and one-time payment in the same flow.

Error Response Parameters

Given below is a list of possible errors you may face while making the authorisation payment.

adequate_funds_not_available_blocked

  • Description: Sufficient unblocked funds not available in customer’s account. Please ask customer to add fund and try again.
  • Next Steps: Please ask customer to add sufficient unblocked funds and try again.

bad_request_error

  • Description: Invalid Mandate Sequence Number.
  • Next Steps: Retry after some time during the valid cycle.

bank_account_invalid

  • Description: Payment failed because Account linked to VPA is invalid.
  • Next Steps: Create a new mandate with the customer.

bank_account_validation_failed

  • Description: Payment was unsuccessful as the details are invalid. Please retry with the right details.
  • Next Steps: Ask the customer to retry again.

bank_not_available

  • Description: Payment was unsuccessful as the bank linked to this UPI ID is temporarily unavailable. Any amount deducted will be refunded within 5-7 working days.
  • Next Steps: Retry after some time.

bank_technical_error

Bank Temporarily Unavailable
  • Description: Payment was unsuccessful as the bank linked to this UPI ID is temporarily unavailable. Any amount deducted will be refunded within 5-7 working days.
  • Next Steps: Retry after some time.

Temporary Bank Issue

  • Description: Payment was unsuccessful due to a temporary issue at your bank. Any amount deducted will be refunded within 5-7 working days.
  • Next Steps: Retry after some time.

Bank Declined

  • Description: Payment was unsuccessful as it was declined by your bank. Any amount deducted will be refunded within 5-7 working days.
  • Next Steps: Retry after some time.

Bank or Wallet Gateway Error

  • Description: Payment processing failed due to error at bank or wallet gateway.
  • Next Steps: Retry after some time.

General Temporary Issue

  • Description: Payment was unsuccessful due to a temporary issue. Any amount deducted will be refunded within 5-7 working days.
  • Next Steps: Retry after some time.

Bank Services Halt

  • Description: Payment was unsuccessful due to a temporary halt of services at this bank.
  • Next Steps: Retry after some time.

credit_to_beneficiary_failed

  • Description: Payment was unsuccessful due to a temporary issue. Any amount deducted will be refunded within 5-7 working days.
  • Next Steps: Retry after some time.

debit_declined

  • Description: Payment was unsuccessful as it was declined by remitter bank.
  • Next Steps: Create a new mandate with the customer.

debit_instrument_blocked

  • Description: Payment was unsuccessful as the account linked to this UPI ID is blocked. Try using another account.
  • Next Steps: Create a new mandate with the customer.

duplicate_mandate_request

  • Description: Duplicate mandate request. Please try again with another mandate request.
  • Next Steps: Please try again with another mandate request.

gateway_technical_error

Bank or Wallet Gateway Error
  • Description: Payment processing failed due to error at bank or wallet gateway.
  • Next Steps: Retry after some time.

Temporary Issue with Money Deduction

  • Description: Payment was unsuccessful due to a temporary issue. If money got deducted, reach out to the seller.
  • Next Steps: Retry after some time.

incorrect_pin

  • Description: You have entered an incorrect PIN on the UPI app. Please retry with the correct PIN.
  • Next Steps: Ask the customer to retry with correct PIN.

insufficient_funds

  • Description: Transaction failed due to insufficient funds.
  • Next Steps: Ask the customer to add balance to their account and retry.

invalid_request

  • Description: Payment processing failed due to error at bank or wallet gateway.
  • Next Steps: Retry after some time.

invalid_response_from_gateway

  • Description: Payment was unsuccessful due to a temporary issue. Any amount deducted will be refunded within 5-7 working days.
  • Next Steps: Retry after some time.

invalid_transaction_beneficiary

  • Description: Beneficiary address resolution failed. Please try again after some time.
  • Next Steps: Please try again after some time.

invalid_vpa

  • Description: You have entered an incorrect UPI ID. Please retry with the correct UPI ID.
  • Next Steps: Ask the customer to retry with a valid VPA.

issuer_dispatch_failed

  • Description: Payment failed due to some issue at the issuer bank. Please try again after some time.
  • Next Steps: Please try again after some time.

limit_exceeded_remitting_bank

  • Description: Limit exceeded for remitter bank. Please ask customer to try with another bank account.
  • Next Steps: Please ask customer to try with another bank account.

mandate_debit_beyond_psp_amount_cap

  • Description: Debit amount is beyond payer PSP specified amount cap. Please reduce the amount and try again.
  • Next Steps: Please reduce the mandate amount to match customer PSP.

mandate_request_limit_breached

  • Description: Maximum number of mandate creation requests exceeded for customer’s bank account. Please wait for some time before initiating new mandate creation requests.
  • Next Steps: Please wait for some time before initiating new mandate creation requests.

mobile_number_invalid

  • Description: Registered Mobile number linked to the account has been changed or removed.
  • Next Steps: Create a new mandate with the customer.

nature_of_debit_not_allowed

  • Description: Nature of debit not allowed in customer’s account. Please ask the customer to use a different bank account.
  • Next Steps: Please ask the customer to use a different bank account.

no_financial_address_record_found

  • Description: No financial address record found for this VPA. Please ask customer to try with another bank account.
  • Next Steps: Please ask customer to try with other bank account.

no_original_request_found

  • Description: No mandate details were found in the record during debit. Please try after some time.
  • Next Steps: Please try after some time.

payment_collect_request_expired

  • Description: Payment was unsuccessful as you could not pay with the UPI app within time.
  • Next Steps: Retry after some time.

payment_declined

Bank Declined Payment
  • Description: Payment was unsuccessful as it was declined by your bank. Any amount deducted will be refunded within 5-7 working days.
  • Next Steps: Ask the customer to retry with other account.

Customer Declined Payment

  • Description: You have declined the payment request on the UPI app. Please retry when you are ready.
  • Next Steps: Ask the customer to approve the payment.

payment_failed

  • Description: Payment was unsuccessful due to a temporary issue. If amount got deducted, it will be refunded within 5-7 working days.
  • Next Steps: Retry after 1 hour.

payment_pending

  • Description: The status of your payment is pending. You can either wait or retry to pay successfully.
  • Next Steps: Retry after some time.

payment_risk_check_failed

  • Description: Payment was unsuccessful as your account does not pass the risk checks done by your bank. Try using another account.
  • Next Steps: Retry after some time.

payment_timed_out

  • Description: Payment was unsuccessful as you could not complete it in time.
  • Next Steps: Retry after some time.

pre_debit_notification_failed

  • Description: Unable to Notify the Customer.
  • Next Steps: Retry after some time.

remitter_dispatch_failed

  • Description: Payment failed due to some issue at the customer’s. Please try again after some time.
  • Next Steps: Please try again after some time.

request_timed_out

General Timeout - Temporary Issue
  • Description: Payment was unsuccessful due to a temporary issue. Any amount deducted will be refunded within 5-7 working days.
  • Next Steps: Retry after some time.

Timeout - Bank Declined

  • Description: Payment was unsuccessful as it was declined by your bank. Any amount deducted will be refunded within 5-7 working days.
  • Next Steps: Retry after some time.

Timeout - Recurring Payment Creation

  • Description: Payment was unsuccessful as the recurring payment can not be created at this time. Any amount deducted will be refunded within 5-7 working days.
  • Next Steps: Retry after some time.

transaction_frequency_limit_exceeded

  • Description: Payment failed. Please try again with another bank account.
  • Next Steps: Create a new mandate with the customer.

transaction_limit_exceeded

Amount Limit Exceeded
  • Description: Payment failed because Transaction amount limit has exceeded.
  • Next Steps: Reach out to the customer to collect the amount.

Bank Account Amount Limit

  • Description: Payment was unsuccessful as you exceeded the amount limit on the bank account linked to this UPI id.
  • Next Steps: Ask the customer to retry after some time.

transaction_not_allowed

  • Description: Payment was unsuccessful as it was declined by your bank. Reach out to your bank for more details. Try using another account.
  • Next Steps: Create a new mandate with the customer.

upi_dummy_payment

  • Description: Payment was a dummy payment for one time mandate registration.
  • Next Steps: NA
Registration Link is an alternate way of creating an authorisation transaction. You can create a registration link using the API or Dashboard.
Handy Tips
When you create a registration link, an invoice is automatically issued to the customer. They can use this invoice to make the authorisation payment. A registration link must always have the amount (in Paise) that the customer will be charged when making the authorisation payment. For UPI, the amount must be a minimum of ₹1. The following endpoint creates a registration link. /subscription_registration/auth_links
Curl

Request Parameters

customer : object Details of the customer to whom the registration link is sent. name mandatory : string Customer’s name. email mandatory : string Customer’s email address. contactmandatory : integer Customer’s contact number. type mandatory : string In this case, the value is link. amount mandatory : integer The payment amount in the smallest currency sub-unit. currency mandatory : string The 3-letter ISO currency code for the payment. description mandatory : string A description that appears on the hosted page. subscription_registration : Details of the authorisation transaction. method mandatory : string The payment method used to make authorisation transaction. Here, it is card. max_amount mandatory : integer Use to set the maximum amount (in paise) per debit request.

MCC | Category | Min Value | Max Value

6211 | Financial Services | 100 (₹1) | 20000000 (₹2,00,000)

6300 | Financial Services | 100 (₹1) | 20000000 (₹2,00,000)

7322 | Financial Services | 100 (₹1) | 20000000 (₹2,00,000)

6529 | Financial Services | 100 (₹1) | 20000000 (₹2,00,000)

5960 | Services | 100 (₹1) | 20000000 (₹2,00,000) For other categories and MCCs, the minimum value is 100 (₹1) and maximum value is 9999900 (₹99,999). expire_at optional : integer The Unix timestamp till when you can use the token to charge the customer subsequent payments. The default value is 10 years and the maximum value allowed is 30 years. frequency mandatory : string The frequency at which you can charge your customer. Possible values:
  • daily
  • weekly
  • fortnightly
  • bimonthly
  • monthly
  • quarterly
  • half_yearly
  • yearly
  • as_presented
recurring_value optional : integer Determines the exact date or range of dates for recurring debits. Possible values are:
  • 1-7 for weekly frequency
  • 1-31 for fortnightly frequency
  • 1-31 for bimonthly frequency
  • 1-31 for monthly frequency
  • 1-31 for quarterly frequency
  • 1-31 for half_yearly frequency
  • 1-31 for yearly frequency and is not applicable for the as_presented frequency.
Watch Out!If the date entered for the recurring debit is not available for a month, then the last day of the month is considered by default. For example, if the date entered is 31 and the month has only 28 days, then the date 28 is considered.recurring_type optional : string Determines when the recurring debit can be done. Possible values are:
  • on: recurring debit happens on the exact day of every month.
  • before: recurring debit can happens any time before the specified date.
  • after: recurring debit can happens any time after the specified date.
For example, if the frequency is monthly, recurring_value is 17 and recurring_type is before, recurring debit can happen between the month’s 1st and 17th. Similarly, if recurring_type is after, recurring debit can only happen on or after the 17th of the month.bank_account mandatory : Details of the bank account of the customer.account_number mandatory : integer The bank account number of the customer. For example, 123456789012345.name mandatory : string The name of the bank account holder.ifsc mandatory : string The IFSC of the bank. For example, HDFC0000053.sms_notify optional : boolean Indicates if SMS notifications are to be sent by Razorpay. Possible values:
  • true (default): Notifications are sent by Razorpay .
  • false: Notifications are not sent by Razorpay.
email_notify optional : boolean Indicates if email notifications are to be sent by Razorpay. Possible values:
  • true (default): Notifications are sent by Razorpay .
  • false: Notifications are not sent by Razorpay.
expire_by optional : integer The Unix timestamp indicates the expiry of the registration link.receipt optional : string A unique identifier entered by you for the order. For example, Receipt No. 1. You should map this parameter to the order_id sent by Razorpay.notes optional : object This is a key-value pair that is used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, "note_key": "Beam me up Scotty”.

1.2.2. Send/Resend Notifications

The following endpoint sends/resends notifications with the short URL to the customer: /invoices/:id/notify_by/:medium

Sample Code

Curl
Response

Path Parameters

idmandatory : string The unique identifier of the invoice linked to the registration link for which you want to send the notification. For example, inv_1Aa00000000001. medium mandatory : string Determines through which medium you want to resend the notification. Possible values:
  • sms
  • email
The following endpoint cancels a registration link. /invoices/:id/cancel
Handy Tips
You can only cancel registration link in the issued state.

Sample Code

Curl
Response

Path Parameter

id mandatory : string The unique identifier for the invoice linked to the registration link that you want to cancel. For example, inv_1Aa00000000001.